Program SzekvencialisFileListazasok;{MEGOLDS: 1.fel. 2.mo.-ra a/b-vltozat}
         {Az sszfokozatos listzs el}
{
  Feladat:
    Az albbi szerkezet file beolvassa s kilistzsa
    1. lapozottan, ill. gy, hogy
    2. az egy tanszken dolgozk kifrjenek egy lapra
       (a tanszk nyitrekorddal egytt).
       Ef: nincs tanszk, ahol tbben dolgoznnak, mint a kpernysorok
           szma-1.

  File-szerkezet:

    1. szint: EGYETEM
      szintkd, nv, rektori hivatal cm, tel.szm
      karok

    2. szint: KAR
      szintkd, nv, dkni hivatal cm, tel.szm
      tanszkek (tanszki egysgek)

    3. szint: TANSZKEK
      szintkd, nv, tanszkcm, tel.szm
      dolgozk

    4. szint: DOLGOZ
      szintkd, nv, lakcm, tel.szm, fizets, ...

    Felttelezs:
      A file strukturlisan helyes, nem res.

    Megjegyzs:
      A file csupa azonos tpus elembl ll. Ezrt a struktra-
      nyit elemek kiegszlnek --"tartalom nlkli"-- mezkkel,
      amelyeket esetleg fl lehet hasznlni az sszegfokozatok
      utlagos trolsra.
}
  Uses  Newdelay,Crt;

  {$i Randnev.inc}

  Type  TSzint=(Dolgozo,Tanszek,Kar,Egyetem,Ures);
  Const KSzint:Array [TSzint] of String=(' ','T','K','E','');{kiirand}
        szintKodH=1; nevH=28; cimH=26; telH=9; fizuH=6;      {kirshossz}
  Type  TElem=Record
                szintKod:TSzint;
                nev:String[nevH]; cim:String[cimH]; tel:String[telH];
                fiz:LongInt;
        End;
  Type  TFile=File of TElem;
        TMegnyitasMod=(Letrehozas,Olvasas);
  Const LaphOssz=20;

  {$i osszfok.inc --
      ebben tallhatk a lnyeg szemponjbl kevsb fontos
      ltalnos konstansok, vltozk, eljrsok, fggvnyek.
      Pl. Var sor:Byte, ami a kpernyre kiirt sorok szmt tartalmazza
          Procedure ElemKi kir egy elemet a fejlchez igazodva (izlsesen)
          Procedure Lapoz, ami lapot trl, s fejlcet r ki, sor-t nullz
          Procedure BillreVar, ami billenyty-lenyomsra vr
          Procedure Megnyit file-t, megfelelo modon
          Procedure General adatfile-t a fenti szerkezetben
          Procedure Lezar file-t
          Procedure Inic, ami inicalizlja a kiirst (~MegnyitLista)
  }

{
   Listz rutinok:
   1. Listaz
      -- egyszer (termszetes) virtlis tpus bevezetsvel
   2. ListazMaskent
      -- (ltalnosthat) virtlis tpus bevezetsvel
         (tban a tanszkenktni listzs fel)
   3. TanszTordListaz
     -- listzs 'tanszk dologozk egytt maradsval' felttellel
}
  Procedure Listaz(Var f:TFile);
  (*
    Virtulis tpusok:
    Input:  TBeLap=TFile
            BeNyit,BeVge?,BeOlvas,BeZr
            (A reprezentci egyszersge miatt:)
            * BeNyit=Megnyitas,
            * BeVge?=Eof,
            * BeOlvas=Read,
            * BeZr=Lezar
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
                  =sor:Egsz
            KiNyit,KiIr,KiZr
            * KiNyit=Lapoz,
            * KiIr=ElemKi,
            * KiZr=Vrakozs + ClrScr
  *)
  Begin{Listaz}
    (* ide kell valami *)
  End{Listaz};

(* ----------------------------------------------------------------- *)

  Procedure ListazMaskent(Var f:TFile);
  (*
    Virtulis tpusok:
    Input:  TBeLap=Rekord(db:Egsz, sorok:Tmb(1..LapHossz:TElem))
            BeNyit,BeVge?,BeOlvas,BeZr
            * BeNyit=
              a) Megnyitas+belap-puffer inicializls,
              b) Megnyitas+semmi
            * BeVge?=Eof,
            * BeOlvas=
              a) pufferbe olvass betelsig,
              b) pufferbe olvass 1-tl, amg lehet
            * BeZr=Lezar
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
                  =sor:Egsz
            KiNyit,KiIr(belap-puffer!),KiZr
            * KiNyit=Lapoz,
            * KiIr=
              a) belap-puffer kirsa
                  + vrakozs
                  + Lapoz
                  + puffer inicializlsa
              b) belap-puffer kirsa
                  + vrakozs
                  + Lapoz
                  + (a puffert nem vltoztatja meg!)
            * KiZr=Vrakozs (ha kell) + ClrScr
  *)
  Begin{ListazMaskent}
    (* ide kell valami *)
  End{ListazMaskent};

(* ----------------------------------------------------------------- *)

  Procedure TanszTordListaz(Var f:TFile);
  (*
    Virtulis tpusok:
    Input:  bemeneti egysg vagy egy tanszk sszes dolgozja a nyitval
                            vagy valami ms elem
            a bementi eleme hatrt csak elreolvassi technikval
            tudjuk megtallni
            TBeEgyseg=Rekord(db:Egsz,
                             e:TElem [az elreolvasott],
                             sorok:Tmb(1..MaxTszDolg+1:TElem))
            Elfelttel => MaxTszDolg+1=LapHossz
            BeNyit,BeVge?,BeOlvas,BeZr
            * BeNyit=Megnyitas+belap-puffer inicializls+elreolvass
            * BeVge?=Eof,
            * BeOlvas=egysgolvass elreolvasssal,
            * BeZr=Lezar
    Output: TKiLap="Rekord"(sor:Egsz,kperny:TKperny)
                  =sor:Egsz
            KiNyit,KiIr(belap-puffer!),KiZr
            * KiNyit=Lapoz,
            * KiIr=belap-puffer kirsa+sor-llts, ha mg kifr
                   ha nem fr ki, akkor
                   + vrakozs
                   + Lapoz
                   + puffer inicializlsa
            * KiZr=Vrakozs + ClrScr
  *)
  Begin{TanszTordListaz}
    (* ide kell valami *)
  End{TanszTordListaz};

  Var
    egy:TFile;

Begin
  Inic;

  ClrScr;
  HighVideo; Writeln(Kozepre('File-ltrehozs',80)); NormVideo;
  Megnyit(egy,Letrehozas);
  General(egy);
  Lezar(egy);

  ClrScr;
  HighVideo; Writeln(Kozepre('Sma listzs',80)); NormVideo;
 {Sima listzs:}
  Listaz(egy);

  ClrScr;
  HighVideo; Writeln(Kozepre('Sma listzs -- msknt',80)); NormVideo;
 {Sima listzs, msknt:}
  ListazMaskent(egy);

  ClrScr;
  HighVideo; Writeln(Kozepre('Tanszkre trdelt listzs',80)); NormVideo;
 {TanszkreTrdeltListzs:}
  TanszTordListaz(egy);
End.
